#include QMK_KEYBOARD_H
#include "drashna.h"

// qmk compile --keyboard tkc/osav2 --keymap drashna

// clang-format off
#define LAYOUT_alice_base( \
    K01, K02, K03, K04, K05, K06, K07, K08, K09, K0A, \
    K11, K12, K13, K14, K15, K16, K17, K18, K19, K1A, \
    K21, K22, K23, K24, K25, K26, K27, K28, K29, K2A  \
  ) \
  LAYOUT_all( \
        KC_MPLY,    KC_GRV,     KC_1,   KC_2,   KC_3,   KC_4,   KC_5,   KC_6,   /**/   KC_7,   KC_8,   KC_9,   KC_0,   KC_MINS,    KC_EQL,     KC_BSLS, KC_DEL,     \
        KC_VOLU,    KC_TAB,     K01,    K02,    K03,    K04,    K05,            /**/   K06,    K07,    K08,    K09,    K0A,        KC_LBRC,    KC_RBRC, KC_BSPC,    \
        KC_VOLD,    KC_ESC,     K11,    K12,    K13,    K14,    K15,            /**/   K16,    K17,    K18,    K19,    K1A,        KC_QUOT,    KC_ENT,              \
                    KC_LSFT,    K21,    K22,    K23,    K24,    K25,            /**/   KC_B, K26,    K27,    K28,    K29,    K2A,         KC_LEAD, MO(_RAISE), \
                    KC_LCTL,          KC_LALT,    KC_SPC, MO(_LOWER), /**/   /*LT(_NAV, KC_SPC),*/MO(_NAV),               KC_RALT,                            KC_RGUI \
    )


/* Re-pass though to allow templates to be used */
#define LAYOUT_alice_base_wrapper(...)       LAYOUT_alice_base(__VA_ARGS__)

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {

    [_QWERTY] = LAYOUT_alice_base_wrapper(
        _________________QWERTY_L1_________________, _________________QWERTY_R1_________________,
        _________________QWERTY_L2_________________, _________________QWERTY_R2_________________,
        _________________QWERTY_L3_________________, _________________QWERTY_R3_________________
    ),

    [_LOWER] = LAYOUT_all(
        secret_1,   KC_GRV,     KC_F1,   KC_F2,   KC_F3,   KC_F4,   KC_F5,   KC_F6,   /**/   KC_F7,   KC_F8,   KC_F9,   KC_F10,   KC_F11,    KC_F12,     KC_BSLS, KC_DEL,     \
        secret_2,   KC_TAB,     _______, _______, _______, _______, _______,            /**/   KC_SLSH, KC_7,    KC_8,    KC_9, KC_MINS,        KC_LBRC,    KC_RBRC, KC_BSPC,    \
        secret_3,   KC_ESC,     _______, KC_MPRV, KC_MPLY, KC_MNXT, _______,            /**/   KC_ASTR, KC_4,    KC_5,    KC_6, KC_COMM,        KC_QUOT,    KC_ENT,              \
                    KC_LSFT,    _______, _______, _______, _______, _______,            /**/   KC_B,   KC_1,    KC_2,    KC_3,KC_0,   KC_EQL,         KC_LEAD, MO(_RAISE), \
                    KC_LCTL,          KC_LALT,    KC_SPC, MO(_LOWER), /**/   LT(_NAV, KC_SPC),               KC_RALT,                            KC_RGUI \
    ),

//     #define _________________LOWER_L1__________________        ___________________BLANK___________________
// #define _________________LOWER_L2__________________        _______, KC_MPRV, KC_MPLY, KC_MNXT, _______
// #define _________________LOWER_L3__________________        ___________________BLANK___________________

// #define _________________LOWER_R1__________________        KC_SLSH, KC_7,    KC_8,    KC_9, KC_MINS
// #define _________________LOWER_R2__________________        KC_ASTR, KC_4,    KC_5,    KC_6, KC_COMM
// #define _________________LOWER_R3__________________        KC_0,    KC_1,    KC_2,    KC_3, KC_EQL

    [_RAISE] = LAYOUT_alice_base_wrapper(
        _________________RAISE_L1__________________, _________________RAISE_R1__________________,
        _________________RAISE_L2__________________, _________________RAISE_R2__________________,
        _________________RAISE_L3__________________, _________________RAISE_R3__________________
    ),
    [_ADJUST] = LAYOUT_alice_base_wrapper(
        _________________ADJUST_L1_________________, _________________ADJUST_R1_________________,
        _________________ADJUST_L2_________________, _________________ADJUST_R2_________________,
        _________________ADJUST_L3_________________, _________________ADJUST_R3_________________
    ),
    // [_NAV] = LAYOUT_alice_base_wrapper(
    //     ___________________NAV_L1__________________, ___________________NAV_R1__________________,
    //     ___________________NAV_L2__________________, ___________________NAV_R2__________________,
    //     ___________________NAV_L3__________________, ___________________NAV_R3__________________
    // ),
    [_NAV] = LAYOUT_all(
        secret_4,   KC_GRV,     _______, _______, _______, _______, _______, _______,   /**/   _______, _______, _______, _______, _______, _______,  _______, KC_DEL,     \
        secret_5,   KC_TAB,     _______, _______, _______, _______, _______,            /**/   KC_HOME, KC_PGDN, KC_PGUP,   KC_END,  _______,    aa,    _______, KC_BSPC,    \
        secret_6,   KC_ESC,     _______, _______, KC_UP  , _______, _______,            /**/   KC_LEFT, KC_DOWN, KC_UP,   KC_RGHT, ae,      oe,    KC_ENT,              \
                    KC_LSFT,    _______, KC_LEFT, KC_DOWN, KC_RGHT, _______,            /**/   KC_B, _______, _______, _______, _______, _______,KC_LEAD, MO(_RAISE), \
                    KC_LCTL,          KC_LALT,    KC_SPC, MO(_LOWER), /**/   LT(_NAV, KC_SPC),               KC_RALT,                            KC_RGUI \
    ),

// #define ___________________NAV_L1__________________        DF(_QWERTY), DF(_WORKMAN), TG(_WARCRAFT), TG(_DIABLO), TG(_HEROES)      
// #define ___________________NAV_L2__________________        _______, _______, KC_UP  , _______, _______
// #define ___________________NAV_L3__________________        _______, KC_LEFT, KC_DOWN, KC_RGHT, _______

// //#define ___________________NAV_R1__________________        KC_PGUP, KC_HOME, KC_UP,   KC_END,  aa
// #define ___________________NAV_R1__________________        KC_HOME, KC_PGDN, KC_PGUP,   KC_END,  aa
// // #define ___________________NAV_R2__________________        KC_PGDN, KC_LEFT, KC_DOWN, KC_RGHT, ae
// #define ___________________NAV_R2__________________        KC_LEFT, KC_DOWN, KC_UP,   KC_RGHT, ae
// #define ___________________NAV_R3__________________        _______, _______, _______, _______, oe




//     [_LAYERINDEX] = LAYOUT_wrapper(
//       _______, _______, _______, _______, _______, _______,                                       _______, _______, _______, _______, _______, _______,
//       _______, _______, _______, _______, _______, _______,                                       _______, _______, _______, _______, _______, _______,
//       _______, _______, _______, _______, _______, _______, _______, _______,   _______, _______, _______, _______, _______, _______, _______, _______,
//                                  _______, _______, _______, _______, _______,   _______, _______, _______, _______, _______
//     ),
};
// clang-format on