# Quantum Mechanical Keyboard Firmware
> This is a fork of the official [GitHub Repo](https://github.com/qmk/qmk_firmware) of QMK. 
> This repo only contains userspace for my layouts and the layouts themselves. 

## Boards

The repo only contains keymaps for my own boards. The keymaps can be changed to other layouts as well. 

### Current

* [Melody96](keyboards/melody96)
* [UT47.5](keyboards/ut472)
* [Kyria](keyboards/kyria)
* [Drop ALT](keyboards/massdrop/alt)
* [ElectroType Acrylic Alice](https://switchcouture.com/) (Q3 - 2020)
* [Lily58](FrederikBaerentsen/QMK/src/branch/master/keyboards/lily58) (Q2 - 2020)
* [SPACE65:CyberVoyager](https://graystudio.club/) (Q4 - 2020)
* [Uno](https://www.reddit.com/r/mechmarket/comments/gyijm7/gb_uno/) (Q3 - 2020)

### Incoming

* [Rukia R2](https://www.mintautumn.com/) (Est. ~~Q4 - 2020~~ Q2 - 2021)
* [Think65 V2](https://graystudio.club/) (Est. Q2 - 2020)
* ~~[Klippe T R4](https://mekanisk.co/) (Est. Q3)~~


## Keyboard-layout-editor

All the boards should be available on keyboard-layout-editor.com.

* [Kyria](http://www.keyboard-layout-editor.com/#/gists/e0a6bd87b1e727555ec5c5c1b82c3670)
* [Lily58](http://www.keyboard-layout-editor.com/#/gists/ef22a088bdb96962de3b8b5ae4cd3951)
* [UT47.2](http://www.keyboard-layout-editor.com/#/gists/5ab8838c07cdb2fc41f3dd9a8b177bf4)
* [Melody96](http://www.keyboard-layout-editor.com/#/gists/8a16447546079e942b151523ac2356b8)
* [SC Alice](http://www.keyboard-layout-editor.com/#/gists/d4e2669ee1344ea9a648220a490030c5)

## Keymaps

All my keymaps are based on the userspace from [Drashna](https://github.com/qmk/qmk_firmware/tree/master/users/drashna). This is probably the most advanced userspace I've seen and I have heavily borrowed from it (read: copy/paste). 

The main idea is to have a wrapper where let's say QWERTY is stored. This wrapper can be used for both UT47.2 and Kyria because they both have the same 3x10 keys for alphas. The mods are different, but that does not matter. 

A QWERTY wrapper can look like: 

```
#define _________________QWERTY_L1_________________        KC_Q,    KC_W,    KC_E,    KC_R,    KC_T
#define _________________QWERTY_L2_________________        KC_A,    KC_S,    KC_D,    KC_F,    KC_G
#define _________________QWERTY_L3_________________        KC_Z,    KC_X,    KC_C,    KC_V,    KC_B

#define _________________QWERTY_R1_________________        KC_Y,    KC_U,    KC_I,    KC_O,    KC_P
#define _________________QWERTY_R2_________________        KC_H,    KC_J,    KC_K,    KC_L,    KC_SCLN
#define _________________QWERTY_R3_________________        KC_N,    KC_M,    KC_COMM, KC_DOT,  KC_SLASH
```

When added to Kyria it will look like:

<img src="https://gitea.baerentsen.space/FrederikBaerentsen/QMK/raw/branch/master/UT472_QWERTY.PNG" width="500">

And on UT47.2: 

<img src="https://gitea.baerentsen.space/FrederikBaerentsen/QMK/raw/branch/master/Kyria_QWERTY.PNG" width="500">

Both has the same QWERTY layout and we can add mods around it. 
This isn't super useful for just alphas, but adding symbols and other layers it suddenly becomes much easier to add new keyboards. 
