#include "drashna.h"

extern uint8_t is_master;
#if defined(OLED_DISPLAY_128X64) || defined(OLED_DISPLAY_128X32)

    #ifndef KEYLOGGER_LENGTH
    // #    ifdef OLED_DISPLAY_128X64
    #    define KEYLOGGER_LENGTH ((int)(OLED_DISPLAY_HEIGHT / OLED_FONT_WIDTH))
    // #    else
    // #        define KEYLOGGER_LENGTH (uint8_t *(OLED_DISPLAY_WIDTH / OLED_FONT_HEIGHT))
    // #    endif
    #endif

    static uint32_t oled_timer                       = 0;
    static char     keylog_str[KEYLOGGER_LENGTH + 1] = {"\n"};
    static uint16_t log_timer                        = 0;

    // clang-format off
    static const char PROGMEM code_to_name[0xFF] = {
    //   0    1    2    3    4    5    6    7    8    9    A    B    c    D    E    F
        ' ', ' ', ' ', ' ', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',  // 0x
        'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '1', '2',  // 1x
        '3', '4', '5', '6', '7', '8', '9', '0',  20,  19,  27,  26,  22, '-', '=', '[',  // 2x
        ']','\\', '#', ';','\'', '`', ',', '.', '/', 128, ' ', ' ', ' ', ' ', ' ', ' ',  // 3x
        ' ', ' ', ' ', ' ', ' ', ' ', 'P', 'S', ' ', ' ', ' ', ' ',  16, ' ', ' ', ' ',  // 4x
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // 5x
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // 6x
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // 7x
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // 8x
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // 9x
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // Ax
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // Bx
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // Cx
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // Dx
        'C', 'S', 'A', 'C', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ',  // Ex
        ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '        // Fx
    };
    // clang-format on

    void add_keylog(uint16_t keycode) {
        if ((keycode >= QK_MOD_TAP && keycode <= QK_MOD_TAP_MAX) || (keycode >= QK_LAYER_TAP && keycode <= QK_LAYER_TAP_MAX) || (keycode >= QK_MODS && keycode <= QK_MODS_MAX)) {
            keycode = keycode & 0xFF;
        } else if (keycode > 0xFF) {
            keycode = 0;
        }

        for (uint8_t i = (KEYLOGGER_LENGTH - 1); i > 0; --i) {
            keylog_str[i] = keylog_str[i - 1];
        }

        if (keycode < (sizeof(code_to_name) / sizeof(char))) {
            keylog_str[0] = pgm_read_byte(&code_to_name[keycode]);
        }

        log_timer = timer_read();
    }

    bool process_record_user_oled(uint16_t keycode, keyrecord_t *record) {
        if (record->event.pressed) {
    #ifdef OLED_DRIVER_ENABLE
            oled_timer = timer_read32();
            add_keylog(keycode);
    #endif
        }
        return true;
    }

    void update_log(void) {
        if (timer_elapsed(log_timer) > 750) {
            // add_keylog(0);
        }
    }

    void render_keylogger_status(void) {
        oled_write_P(PSTR(OLED_RENDER_KEYLOGGER), false);
        oled_write(keylog_str, false);
    }

    void render_default_layer_state(void) {
        oled_write_P(PSTR(OLED_RENDER_LAYOUT_NAME), false);
        switch (get_highest_layer(layer_state)) {
            case _DIABLO:
                oled_write_P(PSTR(OLED_RENDER_LAYOUT_DIABLO), false);
                break;
            case _WARCRAFT:
                oled_write_P(PSTR(OLED_RENDER_LAYOUT_WARCRAFT), false);
                break;
            case _HEROES:
                oled_write_P(PSTR(OLED_RENDER_LAYOUT_HEROES), false);
                break;

            default:
                switch (get_highest_layer(default_layer_state)) {
                    case _WORKMAN:
                        oled_write_P(PSTR(OLED_RENDER_LAYOUT_WORKMAN), false);
                        break;
                    case _QWERTY:
                        oled_write_P(PSTR(OLED_RENDER_LAYOUT_QWERTY), false);
                        break;
                }
        }
        oled_advance_page(true);
    }

    // void render_default_layer_state(void) {
    //     oled_write_P(PSTR(OLED_RENDER_LAYOUT_NAME), false);
    //     oled_write_P(PSTR(OLED_RENDER_LAYOUT_QWERTY), layer_state_is(_QWERTY));
    //     oled_write_P(PSTR(OLED_RENDER_LAYOUT_DIABLO), layer_state_is(_WARCRAFT));
    //     oled_write_P(PSTR(OLED_RENDER_LAYOUT_WARCRAFT), layer_state_is(_DIABLO));
    //     oled_advance_page(true);
    // }

    void render_layer_state(void) {
        #ifdef OLED_DISPLAY_128X64
            oled_write_P(PSTR(OLED_RENDER_LAYER_NAME), false);
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_LOWER), layer_state_is(_LOWER));
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_RAISE), layer_state_is(_RAISE));
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_MODS), layer_state_is(_MODS));
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_NAV), layer_state_is(_NAV));
            oled_advance_page(true);
        #endif
        #ifdef OLED_DISPLAY_128X32
            oled_write_P(PSTR(OLED_RENDER_LAYER_NAME), false);
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_LOWER), layer_state_is(_LOWER));
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_RAISE), layer_state_is(_RAISE));
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_MODS), layer_state_is(_MODS));
            oled_write_P(PSTR(" "), false);
            oled_write_P(PSTR(OLED_RENDER_LAYER_NAV), layer_state_is(_NAV));
            //oled_advance_page(true);
        #endif
    }

    void render_keylock_status(uint8_t led_usb_state) {
        oled_write_P(PSTR(OLED_RENDER_LOCK_NAME), false);
        oled_write_P(PSTR(" "), false);
        oled_write_P(PSTR(OLED_RENDER_LOCK_NUML), led_usb_state & (1 << USB_LED_NUM_LOCK));
        oled_write_P(PSTR(" "), false);
        oled_write_P(PSTR(OLED_RENDER_LOCK_CAPS), led_usb_state & (1 << USB_LED_CAPS_LOCK));
        oled_write_P(PSTR(" "), false);
        oled_write_P(PSTR(OLED_RENDER_LOCK_SCLK), led_usb_state & (1 << USB_LED_SCROLL_LOCK));
        oled_advance_page(true);
    }

    void render_mod_status(uint8_t modifiers) {
        oled_write_P(PSTR(OLED_RENDER_MODS_NAME), false);
        oled_write_P(PSTR(OLED_RENDER_MODS_SFT), (modifiers & MOD_MASK_SHIFT));
        oled_write_P(PSTR(" "), false);
        oled_write_P(PSTR(OLED_RENDER_MODS_CTL), (modifiers & MOD_MASK_CTRL));
        oled_write_P(PSTR(" "), false);
        oled_write_P(PSTR(OLED_RENDER_MODS_ALT), (modifiers & MOD_MASK_ALT));
        oled_write_P(PSTR(" "), false);
        oled_write_P(PSTR(OLED_RENDER_MODS_GUI), (modifiers & MOD_MASK_GUI));
    }

    __attribute__((weak)) void oled_driver_render_logo(void) {
        // clang-format off
        static const char PROGMEM qmk_logo[] = {
            0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,0x90,0x91,0x92,0x93,0x94,
            0xa0,0xa1,0xa2,0xa3,0xa4,0xa5,0xa6,0xa7,0xa8,0xa9,0xaa,0xab,0xac,0xad,0xae,0xaf,0xb0,0xb1,0xb2,0xb3,0xb4,
            0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,0xd0,0xd1,0xd2,0xd3,0xd4,0};
        // clang-format on
        oled_write_P(qmk_logo, false);
    }

    void render_status_secondary(void) {
    #if !defined(SPLIT_TRANSPORT_MIRROR) || defined(OLED_DRIVER_128x64) || defined(OLED_DRIVER_128x32)
        oled_driver_render_logo();
    #endif
    #ifdef SPLIT_TRANSPORT_MIRROR
        /* Show Keyboard Layout  */
        render_default_layer_state();
        render_layer_state();
        render_mod_status(get_mods() | get_oneshot_mods());
        render_keylogger_status();

    #endif
    }
    // clang-format on

    void render_status_main(void) {
        /* Show Keyboard Layout  */
        render_default_layer_state();
        render_layer_state();
        #ifdef RGBLIGHT_ENABLE
            render_keylock_status(host_keyboard_leds());
        #else
            //render_keylock_status(host_keyboard_leds());
        #endif

        //render_mod_status(get_mods() | get_oneshot_mods());

        //render_bootmagic_status();
        //render_user_status();

        render_keylogger_status();
    }

    void oled_task_user(void) {
        update_log();

        if (is_master) {
            render_status_main();  // Renders the current keyboard state (layer, lock, caps, scroll, etc)
        } else {
            render_status_secondary();
        }
    }
#endif